<?php 

namespace Teknisa\CNC\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use \Zeedhi\Framework\Util\Functions;
use Zeedhi\Framework\DTO;
use Teknisa\CNC\Services\LogCNCService;
use Teknisa\CNC\Utilities;

class LogCNC {
    protected $logCNCService;
    protected $utilService;
    
    public function __construct(LogCNCService $logCNCService, Utilities\Util $utilService) {
        $this->logCNCService = $logCNCService;
        $this->utilService = $utilService;
    }
    
    public function findLog(DTO\Request\Filter $request, DTO\Response $response) {
        $result = [];
        
        $conditions = $this->utilService->getParamsAsArray($request);
        $conditions = $this->buildParams($conditions);
        
        if($this->validaConditions($conditions)) {
            $result = $this->logCNCService->findLog($conditions);
            
            $response->addDataSet(new DataSet("log_cnc", $result));
        }
        
        return $result;
    }
    
    private function buildParams($conditions) {
        $result = [];
        
        if(Functions::arrayKeyExists('DTPERIODO', $conditions)) {
            $result['DTINI'] = $conditions['DTPERIODO'][0];
            $result['DTFIN'] = $conditions['DTPERIODO'][1];
        }
        
        return $result;
    }
    
    private function validaConditions($conditions) {
        if((isset($conditions['DTINI']))  && (!empty($conditions['DTFIN']))) {
            return true;
        } else {
            return false;
        }
    }
}