<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class CncEstabelecFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getEstabelec($params){
        $sql = "SELECT DAT.NRESTABELEC, DAT.NMESTABELEC, DAT.CDESTABELEC, DAT.CDFILIAL, DAT.NMFILIAL,DAT.CDEMPRESA, DAT.CDINSCESTA, DAT.CDINSCMUNI, DAT.CDESTABELEC||' - '||DAT.NMESTABELEC AS LABELESTABELEC,
                DAT.CDFILIAL||' - '||DAT.NMFILIAL AS LABELFILIAL,
         N FROM 
               (SELECT D.*, ROWNUM as N 
                FROM 
                     (SELECT E.NRESTABELEC, E.NMESTABELEC, E.CDESTABELEC, E.CDFILIAL, F.NMFILIAL, E.CDEMPRESA, E.CDINSCESTA, E.CDINSCMUNI, E.CDESTABELEC||' - '||E.NMESTABELEC AS LABELESTABELEC, E.NRORG
                       FROM ESTABELECIMENTO E
                        LEFT JOIN FILIAL F
                            ON E.CDFILIAL = F.CDFILIAL
                       WHERE UPPER (E.CDESTABELEC||' - '||E.NMESTABELEC) LIKE UPPER (:LABELESTABELEC)
                        AND E.IDATIVO = 'S'
                       ) D ) DAT 
            WHERE N BETWEEN :FIRST AND :LAST
            AND DAT.NRORG = :NRORG
            ORDER BY DAT.CDFILIAL, DAT.NRESTABELEC, DAT.CDESTABELEC, DAT.NMESTABELEC, LABELESTABELEC";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

        public function getEstabelecAdq($params){
        $sql = "SELECT DISTINCT NRESTABELEC, CDESTABELEC, NMESTABELEC, CDESTABELEC||' - '||NMESTABELEC AS LABELESTABELEC, 'Não' PARAMETRIZADO
                 FROM ( SELECT DAT.NRESTABELEC, DAT.NMESTABELEC, DAT.CDESTABELEC, DAT.CDESTABELEC||' - '||DAT.NMESTABELEC AS LABELESTABELEC, N
                    FROM (
                            SELECT D.*, ROWNUM as N FROM (
                              SELECT NRESTABELEC, NMESTABELEC, CDESTABELEC, CDESTABELEC||' - '||NMESTABELEC AS LABELESTABELEC, NRORG
                                FROM ESTABELECIMENTO
                                WHERE ((INSTR (:P_NRESTABELEC, '|'||TO_CHAR(NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                              ) D
                            ) DAT
                            WHERE DAT.NRORG = :NRORG
                          ) F
                 WHERE NOT EXISTS (SELECT 1
            FROM VALIDACAOADQEST V 
                WHERE V.NRADQUIRENTE = :NRADQUIRENTE
                    AND V.NRORDEM IS NOT NULL 
                    AND V.NRESTABELEC = F.NRESTABELEC)
                UNION
                SELECT V.NRESTABELEC, F.CDESTABELEC, F.NMESTABELEC, F.CDESTABELEC||' - '||F.NMESTABELEC AS LABELESTABELEC, 'Sim' PARAMETRIZADO
                 FROM VALIDACAOADQEST V JOIN(
                                              SELECT DAT.NRESTABELEC, DAT.NMESTABELEC, DAT.CDESTABELEC, DAT.CDESTABELEC||' - '||DAT.NMESTABELEC AS LABELESTABELEC, N
                                              FROM (
                                                SELECT D.*, ROWNUM as N FROM (
                                                  SELECT NRESTABELEC, NMESTABELEC, CDESTABELEC, CDESTABELEC||' - '||NMESTABELEC AS LABELESTABELEC, NRORG
                                                    FROM ESTABELECIMENTO
                                                    WHERE ((INSTR (:P_NRESTABELEC, '|'||TO_CHAR(NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                                                    ORDER BY NRESTABELEC, LABELESTABELEC
                                                  ) D
                                                ) DAT
                                              WHERE N BETWEEN :FIRST AND :LAST
                                              AND DAT.NRORG = :NRORG
                                              ORDER BY DAT.NRESTABELEC, DAT.NMESTABELEC, DAT.CDESTABELEC, LABELESTABELEC
                                            ) F
                ON V.NRESTABELEC = F.NRESTABELEC
                AND V.NRADQUIRENTE = :NRADQUIRENTE
                AND V.NRORDEM IS NOT NULL
                AND V.IDATIVO = 'S'";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getEstabelecAdqFiltered($params, $query){
        $sql = $query; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getEstabelecFiltered($query){
        $sql = $query; 
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
}
